{ stepperDD090712e.spin

  stepper motor driver.  Started July 11, 2009
  Version 090712a drives motor clockwise continuously.  Version c made from a (abadon b).
  Start making this diver more versital.
  stepperDD090712e works!

' Connections (for L293D DIP):
' --------------------------------------
' P0 -> L293D.1 and L293D.9
' P1 -> L293D.2, L293D.3   -> Pin A on motor (far left)
' P2 -> L293D.15, L293D.14 -> Pin B on motor (fourth from left)
' P3 -> L293D.7, L293D.6   -> Pin C on motor (third from left)
' P4 -> L293D.10, L293D.11 -> Pin D on motor (far right)
}

CON

  '_CLKMODE = XTAL1 + PLL16X                            ' this should be in top object
  '_XINFREQ = 5_000_000


  _MinimumStepDelay = 5                                     ' minimum step time  3
  _DefaultExtraDelay = 0
  _InitialPattern = %11001100_11001100_11001100_11001100
  

VAR

  long globalStepsLocation, stepperStack[64], stepsPerRev, stepCounter, stepPattern, delay
  byte enable, pinA, pinB, pinC, pinD, ready, directionFlag

  

PUB Start(startPin, stepsInRev, globalLocation) : success
''  pinA and pinC dive one coil while pinB and pinD drive the other

  globalStepsLocation :=  globalLocation
  enable := startPin
  pinA := startPin + 1
  pinB := startPin + 2
  pinC := startPin + 3
  pinD := startPin + 4
  stepPattern := _InitialPattern
  stepsPerRev := stepsInRev
  delay := _DefaultExtraDelay
  success := cognew(Main, @stepperStack)

  
PRI Main

  dira[enable]~~
  dira[pinA]~~
  dira[pinB]~~
  dira[pinC]~~
  dira[pinD]~~
  outa[enable]~~
  outa[pinA]~
  outa[pinB]~
  outa[pinC]~
  outa[pinD]~
  ready := 1
  repeat
    'ready := 1
    if stepCounter > 0
    
      if directionFlag == 0
        ClockWise
      if directionFlag == 1
        CounterClockWise


PUB DriveSteps(increments, turnDirection) : accept

  if ready == 1
    ready := 0
    directionFlag := turnDirection
    stepCounter := increments
    accept := 1
  else
    accept := 0
  'ready := 1'0
  
PUB DriveRevolutions(revolutions, turnDirection) : accept
''  turnDirection 0 for ClockWise and 1 for CounterClockWise

  if ready == 1
    ready := 0
    directionFlag := turnDirection
    stepCounter := revolutions * stepsPerRev
    accept := 1
  else
    accept := 0
  'ready := 1'0
  
PUB ChangeDelay(newDelayInMilliseconds)

  delay := newDelayInMilliseconds
  
PRI ClockWise

  repeat until (stepCounter-- =< 0)
    stepPattern <-= 1
    outa[pinD..pinA] := stepPattern
    long[globalStepsLocation] += 1
    Pause(_MinimumStepDelay + delay)
  ready := 1  
  

PRI CounterClockWise


  repeat until (stepCounter-- =< 0)
    stepPattern ->= 1
    outa[pinD..pinA] := stepPattern
    long[globalStepsLocation] -= 1
    Pause(_MinimumStepDelay + delay)
  ready := 1    
    
    
PRI Pause(ms) | time

  time := cnt                                              ' sync with system counter
  repeat until (ms-- =< 0)                              ' repeat while time left
    waitcnt(time += clkfreq / 1000)                        ' wait 1 ms